import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.accessibility.*;
import javax.swing.table.*;
import java.sql.*;
import java.awt.*;
import java.awt.event.*;
//import java.beans.*;
import java.util.*;
import java.io.*;
import java.applet.*;
import java.net.*;
import java.math.*;
import java.text.*;

public class GenericReportWriter extends GenericReportWriterForms
   implements ActionListener, ChangeListener, ListSelectionListener
   {
   int connection = 0;
   int reports    = 1;
   int tables     = 2;
   int fields     = 3;
   int sortby     = 4;
   int groupby    = 5;
   int totals     = 6;
   int format     = 7;
   int headings   = 8;
   int generate   = 9;
   int view       = 10;
   String paneChain = String.valueOf(connection);
   int whereAm = 0;
   static String errMsg = "";

   static Connection c;
   ResultSet rs;
   DatabaseMetaData dmtd;
   Statement st;
   String chosenTable;
   String chosenField;
   String chosenReport;
   int oldIndex;
   int selectedFieldsListIndex;
   int size;
   String line;
   boolean tripsThruListEvent = false;
   int wasInWhichPane = 0;
   int linesPerPageint = 0;
   int lineCtrint = 0;
   char ff = 12;
   String mode = "";
   int sqlRet = 0;
   static String propertiesFileMode = "";
   File file;
   String printMode = "";
   PrintWriter out;

   //Create listmodels for JLists
   DefaultListModel reportsPanelReportsListModel = new DefaultListModel();
   JList reportsPanelReportsList = new JList(reportsPanelReportsListModel);

   DefaultListModel tablesPanelTablesListModel = new DefaultListModel();
   JList tablesPanelTablesList = new JList(tablesPanelTablesListModel);

   DefaultListModel fieldsPanelFieldsListModel = new DefaultListModel();
   JList fieldsPanelFieldsList = new JList(fieldsPanelFieldsListModel);

   DefaultListModel fieldsPanelSelectedListModel = new DefaultListModel();
   JList fieldsPanelSelectedList = new JList(fieldsPanelSelectedListModel);

   DefaultListModel groupbyPanelFieldsListModel = new DefaultListModel();
   JList groupbyPanelFieldsList = new JList(groupbyPanelFieldsListModel);

   DefaultListModel groupbyPanelGroupsListModel = new DefaultListModel();
   JList groupbyPanelGroupsList = new JList(groupbyPanelGroupsListModel);

   DefaultListModel totalsPanelGroupsListModel = new DefaultListModel();
   JList totalsPanelGroupsList = new JList(totalsPanelGroupsListModel);

   DefaultListModel sortbyPanelFieldsListModel = new DefaultListModel();
   JList sortbyPanelFieldsList = new JList(sortbyPanelFieldsListModel);

   DefaultListModel sortbyPanelSortedListModel = new DefaultListModel();
   JList sortbyPanelSortedList = new JList(sortbyPanelSortedListModel);

   //Create a file chooser
   final JFileChooser fc = new JFileChooser();

   //Create JText areas
   JTextArea viewPanelTextArea = new JTextArea();
   JTextArea headingsPanelTextArea = new JTextArea();

   //For use by Totals panel and printing
   Vector prevValueVec = new Vector();

   //data[][] used to be public, but works this way
   Object[][] data = new Object[256][2];

   //These vectors are used for totalling when printing.
   //They function as a small flat file database.
   //The first one holds the name of the group whose
   //break causes the total.  The second holds the name
   //of the column being totaled for that group break.
   //The third holds the total itself.
   Vector totalsGrpVec = new Vector();
   Vector totalsColToTotVec = new Vector();
   Vector totalsTotalsVec = new Vector();

   //Models for JTables
   TotalsTableModel totalsPanelTotalsTableModel = new TotalsTableModel();
   JTable totalsPanelTotalsTable = new JTable(totalsPanelTotalsTableModel);

   FormatTableModel formatPanelFormatTableModel = new FormatTableModel();
   JTable formatPanelFormatTable = new JTable(formatPanelFormatTableModel);

   //Vectors used to construct format table
   Vector formatTableVec = new Vector();
   Vector colNamVec = new Vector();
   Vector totWidthVec = new Vector();
   Vector decVec = new Vector();

   public GenericReportWriter(String propertiesFileName)
      {

      ReadPropertiesFile(propertiesFileName);
      if (propertiesFileMode.equals("automatic"))
         {
         //No user is present
         RunAutomatically();
         }

      //Initialize text fields on panels
      linesPerPage.setText("60");
      generatePanelWorkingLabel.setText("");

      SetUpPanels();
      AttachListeners();

      //Set tabs for start-up
      tabbedPane.setSelectedIndex(connection);
      int whereAm = tabbedPane.getSelectedIndex();

      tabbedPane.setEnabledAt(connection, true);
      tabbedPane.setEnabledAt(reports, false);
      tabbedPane.setEnabledAt(tables, false);
      tabbedPane.setEnabledAt(fields, false);
      tabbedPane.setEnabledAt(sortby, false);
      tabbedPane.setEnabledAt(groupby, false);
      tabbedPane.setEnabledAt(totals, false);
      tabbedPane.setEnabledAt(headings, false);
      tabbedPane.setEnabledAt(format, false);
      tabbedPane.setEnabledAt(generate, false);
      tabbedPane.setEnabledAt(view, false);
      }

   public void actionPerformed(ActionEvent e)
      {
      //All button presses are handled from here
      Object pressedButton = e.getSource();

      if (pressedButton == connectionPanelConnectBtn)
         {
         ConnectToDatabase();
         //Set connection tab off and change to reports pane
         tabbedPane.setEnabledAt(connection, false);
         tabbedPane.setEnabledAt(reports, true);
         tabbedPane.setSelectedIndex(reports);
         }

      else if (pressedButton == reportsPanelDeleteBtn)
         {
         chosenReport = reportsPanelReportsList.getSelectedValue().toString();
         try
            {
            sqlRet = st.executeUpdate("delete from GReports where GRepName =  '"+chosenReport+"' ");
            }
         catch(Exception i)
            {
            i.printStackTrace();
            }
         //Save the old index
         oldIndex = reportsPanelReportsList.getSelectedIndex();
         //Remove from this list
         reportsPanelReportsListModel.remove(oldIndex);
         size = reportsPanelReportsListModel.getSize();
         if (size == 0)
            {
            reportsPanelDeleteBtn.setEnabled(false);
            reportsPanelModifyBtn.setEnabled(false);
            reportsPanelRunBtn.setEnabled(false);
            }
         else //Adjust the selection
            {
            if (oldIndex == size) //removed last item
               {
               oldIndex--;
               }
            reportsPanelReportsList.setSelectedIndex(oldIndex); //otherwise select same index
            }
         }

      else if (pressedButton == reportsPanelModifyBtn)
         {
         chosenReport = reportsPanelReportsList.getSelectedValue().toString();
         EmptyAll();
         Retrieve();
         mode = "modify";
         tabbedPane.setEnabledAt(reports, false);
         tabbedPane.setEnabledAt(fields, true);
         tabbedPane.setEnabledAt(sortby, true);
         tabbedPane.setEnabledAt(groupby, true);
         tabbedPane.setEnabledAt(totals, true);
         tabbedPane.setEnabledAt(headings, true);
         tabbedPane.setEnabledAt(format, true);
         tabbedPane.setEnabledAt(generate, true);
         tabbedPane.setEnabledAt(view, true);
         tabbedPane.setSelectedIndex(fields);
         }

      else if (pressedButton == reportsPanelNewBtn)
         {
         mode = "new";
         tabbedPane.setEnabledAt(reports, false);
         tabbedPane.setEnabledAt(tables, true);
         tabbedPane.setSelectedIndex(tables);
         }

      else if (pressedButton == reportsPanelRunBtn)
         {
         chosenReport = reportsPanelReportsList.getSelectedValue().toString();
         mode = "run";
         Retrieve();
         tabbedPane.setEnabledAt(reports, false);
         tabbedPane.setEnabledAt(generate, true);
         tabbedPane.setEnabledAt(view, true);
         tabbedPane.setSelectedIndex(generate);
         }

      else if (pressedButton == tablesPanelSelectBtn)
         {
         chosenTable = tablesPanelTablesList.getSelectedValue().toString();
         FillFieldsList();
         tabbedPane.setEnabledAt(tables, false);
         tabbedPane.setEnabledAt(fields, true);
         tabbedPane.setEnabledAt(sortby, true);
         tabbedPane.setEnabledAt(groupby, true);
         tabbedPane.setEnabledAt(totals, true);
         tabbedPane.setEnabledAt(headings, true);
         tabbedPane.setEnabledAt(format, true);
         tabbedPane.setEnabledAt(generate, true);
         tabbedPane.setEnabledAt(view, true);
         tabbedPane.setSelectedIndex(fields);
         }

      else if (pressedButton == fieldsPanelRightArrowBtn)
         {
         //Add to other list
         fieldsPanelSelectedListModel.addElement(fieldsPanelFieldsList.getSelectedValue());
         fieldsPanelSelectedList.setSelectedValue(fieldsPanelFieldsList.getSelectedValue(), true);
         fieldsPanelLeftArrowBtn.setEnabled(true);
         //Save the old index
         oldIndex = fieldsPanelFieldsList.getSelectedIndex();
         //Remove from this list
         fieldsPanelFieldsListModel.remove(oldIndex);
         size = fieldsPanelFieldsListModel.getSize();
         // Is list empty,  disable right arrow button
         if (size == 0)
            {
            fieldsPanelRightArrowBtn.setEnabled(false);
            }
         else //Adjust the selection
            {
            if (oldIndex == size) //removed last item
               oldIndex--;
            fieldsPanelFieldsList.setSelectedIndex(oldIndex); //otherwise select same index
            }
         }

      else if (pressedButton == fieldsPanelLeftArrowBtn)
         {
         //Add to other list
         fieldsPanelFieldsListModel.addElement(fieldsPanelSelectedList.getSelectedValue());
         fieldsPanelFieldsList.setSelectedValue(fieldsPanelSelectedList.getSelectedValue(), true);
         fieldsPanelRightArrowBtn.setEnabled(true);
         //Save the old index
         oldIndex = fieldsPanelSelectedList.getSelectedIndex();
         //Remove from this list
         fieldsPanelSelectedListModel.remove(oldIndex);
         size = fieldsPanelSelectedListModel.getSize();
         // Is list empty,  disable left arrow button
         if (size == 0)
            {
            fieldsPanelLeftArrowBtn.setEnabled(false);
            }
         else //Adjust the selection
            {
            if (oldIndex == size)//removed last item
               {
               oldIndex--;
               }
            fieldsPanelSelectedList.setSelectedIndex(oldIndex); //otherwise select same index
            }
         }

      else if (pressedButton == sortbyPanelRightArrowBtn)
         {
         //Add to other list
         sortbyPanelSortedListModel.addElement(sortbyPanelFieldsList.getSelectedValue());
         sortbyPanelSortedList.setSelectedValue(sortbyPanelFieldsList.getSelectedValue(), true);
         sortbyPanelLeftArrowBtn.setEnabled(true);
         //Save the old index
         oldIndex = sortbyPanelFieldsList.getSelectedIndex();
         //Remove from this list
         sortbyPanelFieldsListModel.remove(oldIndex);
         size = sortbyPanelFieldsListModel.getSize();
         // Is list empty,  disable right arrow button
         if (size == 0)
            {
            sortbyPanelRightArrowBtn.setEnabled(false);
            }
         else //Adjust the selection
            {
            if (oldIndex == size) //removed last item
               oldIndex--;
            sortbyPanelFieldsList.setSelectedIndex(oldIndex); //otherwise select same index
            }
         }

      else if (pressedButton == sortbyPanelLeftArrowBtn)
         {
         //Add to other list
         sortbyPanelFieldsListModel.addElement(sortbyPanelSortedList.getSelectedValue());
         sortbyPanelFieldsList.setSelectedValue(sortbyPanelSortedList.getSelectedValue(),true);
         sortbyPanelRightArrowBtn.setEnabled(true);
         //Save the old index
         oldIndex = sortbyPanelSortedList.getSelectedIndex();
         //Remove from this list
         sortbyPanelSortedListModel.remove(oldIndex);
         size = sortbyPanelSortedListModel.getSize();
         // Is list empty,  disable left arrow button
         if (size == 0)
            {
            sortbyPanelLeftArrowBtn.setEnabled(false);
            }
         else //Adjust the selection
            {
            if (oldIndex == size)//removed last item
               {
               oldIndex--;
               }
            sortbyPanelSortedList.setSelectedIndex(oldIndex); //otherwise select same index
            }
         }

      else if (pressedButton == groupbyPanelRightArrowBtn)
         { 
         //Add to other list
         groupbyPanelGroupsListModel.addElement(groupbyPanelFieldsList.getSelectedValue());
         groupbyPanelGroupsList.setSelectedValue(groupbyPanelFieldsList.getSelectedValue(), true);
         groupbyPanelLeftArrowBtn.setEnabled(true);
         //Save the old index
         oldIndex = groupbyPanelFieldsList.getSelectedIndex();
         //Remove from this list
         groupbyPanelFieldsListModel.remove(oldIndex);
         size = groupbyPanelFieldsListModel.getSize();
         // Is list empty,  disable right arrow button
         if (size == 0) 
            {
            groupbyPanelRightArrowBtn.setEnabled(false);
            } 
         else //Adjust the selection
            {
            if (oldIndex == size) //removed last item
               oldIndex--;
            groupbyPanelFieldsList.setSelectedIndex(oldIndex); //otherwise select same index
            }
         }

      else if (pressedButton == groupbyPanelLeftArrowBtn)
         {
         //Add to other list
         groupbyPanelFieldsListModel.addElement(groupbyPanelGroupsList.getSelectedValue());
         groupbyPanelFieldsList.setSelectedValue(groupbyPanelGroupsList.getSelectedValue(), true);
         groupbyPanelRightArrowBtn.setEnabled(true);
         //Save the old index
         oldIndex = groupbyPanelGroupsList.getSelectedIndex();
         //Remove from this list
         groupbyPanelGroupsListModel.remove(oldIndex);
         size = groupbyPanelGroupsListModel.getSize();
         // Is list empty,  disable right arrow button
         if (size == 0)
            {
            groupbyPanelLeftArrowBtn.setEnabled(false);
            }
         else //Adjust the selection
            {
            if (oldIndex == size) //removed last item
               oldIndex--;
            groupbyPanelGroupsList.setSelectedIndex(oldIndex); //otherwise select same index
            }
         }

      else if (pressedButton == generatePanelViewBtn)
         {
         generatePanelWorkingLabel.setText("Working");
         RepaintManager rp = RepaintManager.currentManager(this);
         rp.markCompletelyDirty(generatePanelWorkingLabel);
         rp.paintDirtyRegions();
         printMode = "view";
         viewPanelTextArea.setText("");
         WriteReport();
         generatePanelWorkingLabel.setText("");
         viewPanelTextArea.setCaretPosition(0);
         viewPanelTextArea.invalidate();
         tabbedPane.setSelectedIndex(view);
         }

      else if (pressedButton == generatePanelDownloadBtn)
         {
         generatePanelWorkingLabel.setText("Working");
         RepaintManager rp = RepaintManager.currentManager(this);
         rp.markCompletelyDirty(generatePanelWorkingLabel);
         rp.paintDirtyRegions();
         printMode = "file";
         //For next line Sun used prognamname.this, just this works
         int returnVal = fc.showSaveDialog(this);
         if (returnVal == JFileChooser.APPROVE_OPTION)
            {
            file = fc.getSelectedFile();
            try
               {
               out  =  new PrintWriter(new BufferedWriter(new FileWriter(file.toString())));
               }
            catch (Exception f)
               {
               f.printStackTrace();
               }
            WriteReport();
            out.close();
            generatePanelWorkingLabel.setText("");
            }
         }

      else if (pressedButton == generatePanelSaveBtn)
         {
         Save();
         }

      else if (pressedButton == generatePanelSaveAsBtn)
         {
         SaveAs();
         }

      else if (pressedButton == tablesPanelStartOverBtn
         || pressedButton == fieldsPanelStartOverBtn
         || pressedButton == sortbyPanelStartOverBtn
         || pressedButton == groupbyPanelStartOverBtn
         || pressedButton == totalsPanelStartOverBtn
         || pressedButton == formatPanelStartOverBtn
         || pressedButton == headingsPanelStartOverBtn
         || pressedButton == generatePanelStartOverBtn)
         {
         StartOver();
         }
      else if (pressedButton == reportsPanelQuitBtn
         || pressedButton == tablesPanelQuitBtn
         || pressedButton == fieldsPanelQuitBtn
         || pressedButton == sortbyPanelQuitBtn
         || pressedButton == groupbyPanelQuitBtn
         || pressedButton == totalsPanelQuitBtn
         || pressedButton == formatPanelQuitBtn
         || pressedButton == headingsPanelQuitBtn
         || pressedButton == generatePanelQuitBtn)
         {
         Quit();
         }
      else
         {
         System.out.println("else was hit");
         }

      }

   public String AddListToDataString(String name, DefaultListModel lm)
      {
      String d = "";
      for (int i = 0; i < lm.getSize(); i++)
         {
         d = d + name + ">" + lm.elementAt(i).toString()+ "\n";
         }
      return d;
      }

   public String AddVectorToDataString(String name, Vector v)
      {
      String d = "";
      for (int i = 0; i < v.size(); i++)
         {
         d = d + name + ">"+ v.elementAt(i).toString()+ "\n";
         }
      return d;
      }

   public void AttachListeners()
      {
      //Listener for user changing tabs
      tabbedPane.addChangeListener(this);

      // Attach listeners to buttons
      connectionPanelConnectBtn.addActionListener(this);

      reportsPanelDeleteBtn.addActionListener(this);
      reportsPanelModifyBtn.addActionListener(this);
      reportsPanelNewBtn.addActionListener(this);
      reportsPanelRunBtn.addActionListener(this);
      reportsPanelQuitBtn.addActionListener(this);

      tablesPanelSelectBtn.addActionListener(this);
      tablesPanelStartOverBtn.addActionListener(this);
      tablesPanelQuitBtn.addActionListener(this);

      fieldsPanelRightArrowBtn.addActionListener(this);
      fieldsPanelLeftArrowBtn.addActionListener(this);
      fieldsPanelStartOverBtn.addActionListener(this);
      fieldsPanelQuitBtn.addActionListener(this);

      sortbyPanelRightArrowBtn.addActionListener(this);
      sortbyPanelLeftArrowBtn.addActionListener(this);
      sortbyPanelStartOverBtn.addActionListener(this);
      sortbyPanelQuitBtn.addActionListener(this);

      groupbyPanelRightArrowBtn.addActionListener(this);
      groupbyPanelLeftArrowBtn.addActionListener(this);
      groupbyPanelStartOverBtn.addActionListener(this);
      groupbyPanelQuitBtn.addActionListener(this);

      totalsPanelStartOverBtn.addActionListener(this);
      totalsPanelQuitBtn.addActionListener(this);

      formatPanelStartOverBtn.addActionListener(this);
      formatPanelQuitBtn.addActionListener(this);

      headingsPanelStartOverBtn.addActionListener(this);
      headingsPanelQuitBtn.addActionListener(this);

      generatePanelViewBtn.addActionListener(this);
      generatePanelDownloadBtn.addActionListener(this);
      generatePanelSaveBtn.addActionListener(this);
      generatePanelSaveAsBtn.addActionListener(this);
      generatePanelStartOverBtn.addActionListener(this);
      generatePanelQuitBtn.addActionListener(this);

      }

   public String BuildDataString()
      {
      errMsg = "Am in BuildDataString method";
      String reportDataStr = "";

      reportDataStr = "version>001\n";
      reportDataStr = reportDataStr + AddListToDataString("fieldsPanelFieldsListModel", fieldsPanelFieldsListModel);
      reportDataStr = reportDataStr + AddListToDataString("fieldsPanelSelectedListModel", fieldsPanelSelectedListModel);
      reportDataStr = reportDataStr + AddListToDataString("sortbyPanelFieldsListModel", sortbyPanelFieldsListModel);
      reportDataStr = reportDataStr + AddListToDataString("sortbyPanelSortedListModel", sortbyPanelSortedListModel);
      reportDataStr = reportDataStr + AddListToDataString("groupbyPanelFieldsListModel", groupbyPanelFieldsListModel);
      reportDataStr = reportDataStr + AddListToDataString("groupbyPanelGroupsListModel", groupbyPanelGroupsListModel);
      reportDataStr = reportDataStr + AddListToDataString("totalsPanelGroupsListModel", totalsPanelGroupsListModel);
      reportDataStr = reportDataStr + AddVectorToDataString("totalsGrpVec", totalsGrpVec);
      reportDataStr = reportDataStr + AddVectorToDataString("totalsColToTotVec", totalsColToTotVec);
      reportDataStr = reportDataStr + AddVectorToDataString("colNamVec", colNamVec);
      reportDataStr = reportDataStr + AddVectorToDataString("totWidthVec", totWidthVec);
      reportDataStr = reportDataStr + AddVectorToDataString("decVec", decVec);

      //Put on the header
      //but first exclude empty headers
      try
         {
         int linBegOff = 0;
         int linEndOff = 0;
         int linCnt = headingsPanelTextArea.getLineCount();
         if (! (linCnt== 0))
            for (int i = 0; i <= linCnt - 1; i++)  //Start at 0 to include inch scale
               {
               linBegOff = headingsPanelTextArea.getLineStartOffset(i);
               linEndOff = headingsPanelTextArea.getLineEndOffset(i);
               reportDataStr = reportDataStr + "heading>" + headingsPanelTextArea.getText(linBegOff, linEndOff - linBegOff);
               }
         }
      catch(Exception e)
         {
         System.out.println("\nError during BuildDataString method");
         e.printStackTrace();
         }

      reportDataStr = reportDataStr + "chosenTable>" + chosenTable + "\n";
      reportDataStr = reportDataStr + "linesPerPage>" + linesPerPage.getText() + "\n";
      return reportDataStr;
      }

   public void ConnectToDatabase()
      {
      //Make Connection
      try
         {
         Class.forName(connectionPanelDriverClassTxt.getText()).newInstance();
         c = DriverManager.getConnection(
           connectionPanelURLTxt.getText(),
           connectionPanelUserTxt.getText(),
           new String(connectionPanelPasswordTxt.getPassword()));
         st = c.createStatement();

         }
      catch(Exception h)
         {
         h.printStackTrace();
         }
      }

   public static String convertColTypToName(int colTypNo)
      {
      //Converts SQL column type no's to Java type names
      String typNam = "";
      if (colTypNo == -7){typNam = "boolean";}
      if (colTypNo == -6){typNam = "byte";}
      if (colTypNo == -5){typNam = "long";}
      if (colTypNo == -4){typNam = "binary";}
      if (colTypNo == -3){typNam = "binary";}
      if (colTypNo == -2){typNam = "binary";}
      if (colTypNo == -1){typNam = "String";}
      if (colTypNo ==  1){typNam = "String";}
      if (colTypNo ==  2){typNam = "BigDecimal";}
      if (colTypNo ==  3){typNam = "BigDecimal";}
      if (colTypNo ==  4){typNam = "int";  }
      if (colTypNo ==  5){typNam = "short";}
      if (colTypNo ==  6){typNam = "double";}
      if (colTypNo ==  7){typNam = "float";}
      if (colTypNo ==  8){typNam = "double";}
      if (colTypNo == 12){typNam = "String";}
      if (colTypNo == 91){typNam = "Date";}
      if (colTypNo == 92){typNam = "Time";}
      if (colTypNo == 93){typNam = "Timestamp";}
      if (colTypNo == 1111){typNam = "other";}

      return typNam;
      }

   public void EmptyAll()
      {
      //Empty out the vectors
      //reportsPanelReportsListModel.removeAllElements();
      //tablesPanelTablesListModel.removeAllElements();
      fieldsPanelFieldsListModel.removeAllElements();
      fieldsPanelSelectedListModel.removeAllElements();
      sortbyPanelFieldsListModel.removeAllElements();
      sortbyPanelSortedListModel.removeAllElements();
      groupbyPanelFieldsListModel.removeAllElements();
      groupbyPanelGroupsListModel.removeAllElements();
      totalsPanelGroupsListModel.removeAllElements();
      totalsGrpVec.removeAllElements();
      totalsColToTotVec.removeAllElements();
      colNamVec.removeAllElements();
      totWidthVec.removeAllElements();
      decVec.removeAllElements();

      //Empty headings area
      headingsPanelTextArea.setText("");
      //Empty view panel
      viewPanelTextArea.setText("");
      }

   public void FillFieldsList()
      {
      //Fill fields list
      try
         {
         fieldsPanelFieldsListModel.removeAllElements();
         ResultSet rs = dmtd.getColumns(null, null, chosenTable, null);
         while(rs.next())
            {
            String recInfo = rs.getString("COLUMN_NAME");
            fieldsPanelFieldsListModel.addElement(recInfo);
            }
         }
      catch(Exception e)
         {
         e.printStackTrace();
         }
      }

   public void FillFormatPanelFormatTable()
      {
      size = fieldsPanelSelectedListModel.getSize();

      Vector dummyColNamVec = new Vector();
      for (int i = 0; i < size; i++)
         {
         dummyColNamVec.addElement("spaces before " + fieldsPanelSelectedListModel.elementAt(i).toString());
         dummyColNamVec.addElement(fieldsPanelSelectedListModel.elementAt(i));
         }

      formatTableVec = new Vector();

      //Copy into formattablevec
      //along with finding values for width and decimals that already exist
      for (int i = 0; i < size * 2; i++)
         {
         Vector newRow = new Vector();
         Object fieldToLookFor = dummyColNamVec.elementAt(i);
         int searchReturned = colNamVec.indexOf(fieldToLookFor);
         //Put appropriate values into table
         newRow.addElement(fieldToLookFor);
         if (searchReturned >= 0)
            {
            //Get values already assigned
            newRow.addElement(totWidthVec.elementAt(searchReturned));
            newRow.addElement(decVec.elementAt(searchReturned));
            }
         else
            {
            //Wasn't there so use default values
            if (fieldToLookFor.toString().length() >= 12
               && fieldToLookFor.toString().substring(0,13).equals("spaces before"))
               {
               newRow.addElement(new Integer(2));
               totWidthVec.addElement(new Integer(2));
               }
            else
               {
               newRow.addElement(new Integer(10));
               totWidthVec.addElement(new Integer(10));
               }

            newRow.addElement(new Integer(0));
            //Also add it to other vecs
            colNamVec.addElement(fieldToLookFor);
            decVec.addElement(new Integer(0));
            }
         formatTableVec.addElement(newRow);
         }

      formatPanelFormatTableModel.fireTableDataChanged();
      }

   public void FillReportsList()
      {
      try
         {
         //Fill reports list
         rs = st.executeQuery("select * from GReports");
         while(rs.next())
            {
            String recInfo = rs.getString("GRepName");
            reportsPanelReportsListModel.addElement(recInfo);
            }
         rs.close();
         }
      catch(Exception f)
         {
         f.printStackTrace();
         }
      }

   public void FillTablesList()
      {
      try
         {
         //Fill tables list
         dmtd = c.getMetaData();
         String[] types = {"TABLE"};
         rs = dmtd.getTables(null, null, null, types);
         while(rs.next())
            {
            String recInfo = rs.getString("TABLE_NAME");
            tablesPanelTablesListModel.addElement(recInfo);
            }
         rs.close();
         }
      catch(Exception g)
         {
         g.printStackTrace();
         }
      }

   public void FillTotalsPanelTotalsTable(String selectedGroup)
      {
      size = fieldsPanelSelectedListModel.getSize();

      //Begin copying selectedfieldsvec to numFieldsOnlyVec
      //This vec doesn't contain only number fields
      //in spite of its name.  I originally intended to
      //do it that way, but didn't.
      Vector numFieldsOnlyVec = new Vector();
      for (int i = 0; i < size; i++)
         {
         numFieldsOnlyVec.addElement(fieldsPanelSelectedListModel.elementAt(i));
         }

      //Sort the vec before putting into table's array
      //Change--This isn't sorted at this time.
      //I left the line here in case wanted later.
      //Collections.sort(numFieldsOnlyVec);

      //Resize the array to hold data for table
      data = new Object[size][2];

      //Copy array into data array
      //For now assume all cell 0's are false
      for (int i = 0; i < numFieldsOnlyVec.size();i++)
         {
         data[i][0] = new Boolean(false);
         data[i][1] = numFieldsOnlyVec.elementAt(i);
         }
      //Now set true the ones that were true before
      //Interate thru fieldsonly vec
      for (int i = 0; i < numFieldsOnlyVec.size();i++)
         {
         //Look thru totalsgrpvec for match to grp we're looking at
         for (int gvi = 0; gvi < totalsGrpVec.size(); gvi++)
            {
            if (totalsGrpVec.elementAt(gvi).toString().equals(selectedGroup))
               {
               //Now look at colToTot vector for match
               if (numFieldsOnlyVec.elementAt(i).toString().equals(totalsColToTotVec.elementAt(gvi).toString()))
                  {
                  //Change value to true
                  data[i][0] = new Boolean(true);
                  }
               }
            }
         }

      totalsPanelTotalsTableModel.fireTableDataChanged();

      //Debugging at end
    /*  System.out.println("\nAt end of fill routine the data length is " + data.length);
      for (int ix = 0;ix < data.length;ix++)
         {
         System.out.println("data[i][0] is " + data[ix][0]);
         System.out.println("data[i][1] is " + data[ix][1]);
         }
      if (totalsGrpVec.size() == 0)
         {
          System.out.println("totalsgrpVec is empty ");
         }
      for (int i = 0; i < totalsGrpVec.size();i++)
         {
         System.out.println("Row " + i + " of vector is ");
         System.out.println("totalsgrpVec is " + totalsGrpVec.elementAt(i));
         System.out.println("coltotot is " + totalsColToTotVec.elementAt(i));
         }
      */
      }

   public static void main(String[] args)
      {
      GenericReportWriter mainClient = new GenericReportWriter(args[0]);
      mainClient.addWindowListener(new WindowAdapter() {
          public void windowClosing(WindowEvent e) { Quit();}
          });
      mainClient.setVisible(true);
      }

   public static String NumPad(String numStr, int wantLen, int wantDec, String colTypNameNP)
      {
      errMsg = "am inside NumPad";
      int indxDot;
      //Since empty strings cause an error
      if (numStr.length() != 0)
         {
         //If it's in exponential form skip rounding and right padding
         int iE = numStr.indexOf("E");
         if (iE == -1)  //-1 means no E
            {
            //doesn't contain exponent form so do rounding and right padding
            //Set up the format pattern
            String leftFormat = ",###";
            String rightFormat = "";
            if (wantDec > 0)
               {
               rightFormat = ".";
               for (int iRF = 1; iRF <= wantDec; iRF++)
                  {
                  rightFormat = rightFormat + "#";
                  }
               }
            String decFormat = leftFormat + rightFormat;
            DecimalFormat mydf = new DecimalFormat(decFormat);

            if (colTypNameNP.equals("float")
               || colTypNameNP.equals("double"))
               {
               double numdou = Double.valueOf(numStr).doubleValue();
               numStr = mydf.format(numdou).toString();
               //In case there was no decimal point
               //and they want decimal digits to show,
               //formatting it wouldn't have added one
               //so will put it on manually.
               indxDot = numStr.indexOf(".");
               if (wantDec > 0
                  && indxDot == -1)
                  {
                  numStr = numStr + ".";
                  }
               }
            else if (colTypNameNP.equals("int")
               || colTypNameNP.equals("long")
               || colTypNameNP.equals("BigDecimal"))
               {
               BigDecimal numBD = new BigDecimal(numStr);
               numStr = mydf.format(numBD).toString();
               }
            //Pad the right side
            int numStrLen = numStr.length();
            indxDot = numStr.indexOf(".");
            int addHowManyRight = wantDec - (numStrLen - (indxDot + 1));
            if (addHowManyRight > 0
               && indxDot != -1)
               {
               for (int i = 1; i <= addHowManyRight; i++)
                  {
                  numStr = numStr + "0";
                  }
               }
            } //End of numStr didn't contain an E
         else
            {
            //numStr does contain an E
            }

         //Pad the left if necessary
         //Also, if it's already overlength, replace with x's
         //Do this for exponent and non-exponent forms alike
         int howManyLeft = wantLen - numStr.length();
         if (howManyLeft > 0)
            {
            //Needs left padding
            for (int i = 0; i < howManyLeft; i++)
              {
              numStr = " " + numStr;
              }
            }
         else if (howManyLeft < 0)
            {
            //It's overlength, replace with x's
               numStr = "";
               for (int ix = 1; ix <= wantLen; ix++)
                  {
                  numStr = numStr + "x";
                  }
            }

         }  //End of numStr wasn't empty

      else   //numStr was empty to begin with
         {
         numStr = "";
         for (int ix2 = 1; ix2 <= wantLen; ix2++)
            {
            numStr = numStr + "n";
            }
         }
      return numStr;
      }

   public void PrintHeader()
      {
      //Put on the header
      //but first exclude empty headers
      int linBegOff = 0;
      int linEndOff = 0;
      int linCnt = headingsPanelTextArea.getLineCount();
      try
         {
         if (! (linCnt== 0))
            {
            for (int i = 1; i <= linCnt - 1; i++)  //Start at 1 to exclude the inch scale
               {
               linBegOff = headingsPanelTextArea.getLineStartOffset(i);
               linEndOff = headingsPanelTextArea.getLineEndOffset(i) - 1;
               PrintMethod(headingsPanelTextArea.getText(linBegOff, linEndOff - linBegOff));
               }
            }
         lineCtrint = linCnt - 1;  //So we don't count the inch scale line
         }
      catch(Exception e)
          {
          e.printStackTrace();
          }
      }
   public void PrintMethod(String lineStr)
      {
      if (printMode.equals("view"))
         {
         viewPanelTextArea.append(lineStr + "\n");
         }
      else
         {
         try
            {
            out.println(lineStr);
            }
         catch(Exception f)
            {
            f.printStackTrace();
            }
         }
      }

   public void PrintTotals(ResultSetMetaData md, String groupBeingProcessed)
      {
      size = fieldsPanelSelectedListModel.getSize();
      int sizeTotalsGrpVec = totalsGrpVec.size();
      boolean printedTotalForColumn = false;
      String printStr = "";
      String printHyphenStr = "";
      String formattedStr = "";
      String hyphenStr = "";
      String colTypName3 = "";
      String colNameFor = "";
      int colNoFor = 0;
      int totWidFor = 0;
      int decWidFor = 0;
      String precedingSpaces = "";

      //Print totals
      printStr = "";
      printHyphenStr = "";
      try
         {
         //Go top to bottom thru selected fields list
         for (int isfl = 0; isfl <= size -1; isfl++)
            {
            printedTotalForColumn = false;
            errMsg = "inside for isfl";
            //Go top to bottom thru totalsGrpVec
            //Looking for both the group we're processing and the
            //field in selected fields to match
            for (int igv = 0; igv <= sizeTotalsGrpVec -1; igv++)
               {
               errMsg = "inside for igv";
               colNameFor = md.getColumnName(isfl + 1);
               colNoFor = colNamVec.indexOf(colNameFor);
               totWidFor = Integer.valueOf(totWidthVec.elementAt(colNoFor).toString()).intValue();
               if (totalsGrpVec.elementAt(igv).equals(groupBeingProcessed)
                  && totalsColToTotVec.elementAt(igv).equals(fieldsPanelSelectedListModel.getElementAt(isfl)))
                  {
                  errMsg = "inside if that inside for igv";
                  //Create formatted output string
                  colTypName3 = convertColTypToName(md.getColumnType(isfl + 1));
                  //Get formatting info
                  decWidFor = Integer.valueOf(decVec.elementAt(colNoFor).toString()).intValue();
                  formattedStr = NumPad(totalsTotalsVec.elementAt(igv).toString(),totWidFor,decWidFor,colTypName3);
                  //Add -'s to hyphen string
                  hyphenStr = "";
                  for (int ih = 1; ih <= totWidFor; ih++)
                     {
                     if (groupBeingProcessed.equals("End Of Report"))
                        {
                        hyphenStr = hyphenStr + "=";
                        }
                     else
                        {
                        hyphenStr = hyphenStr + "-";
                        }
                     }
                  //Set switch to show printed a total for this column
                  printedTotalForColumn = true;
                  //Zero out the total for that column
                  totalsTotalsVec.setElementAt(String.valueOf(0),igv);
                  }
               }//End of for igv
            if (!printedTotalForColumn)
               {
               //Total didn't print add spaces to printStr
               //Get formatting info
               formattedStr = "";
               hyphenStr = "";
               for (int isp = 1; isp <= totWidFor; isp++)
                  {
                  hyphenStr = hyphenStr + " ";
                  formattedStr = formattedStr + " ";
                  }
               }
            colNoFor = colNamVec.indexOf("spaces before " + colNameFor);
            totWidFor = Integer.valueOf(totWidthVec.elementAt(colNoFor).toString()).intValue();
            precedingSpaces = "";
            for (int iprS = 1;iprS <= totWidFor; iprS++)
               {
               precedingSpaces = precedingSpaces + " ";
               }
            printHyphenStr = printHyphenStr + precedingSpaces + hyphenStr;
            printStr = printStr + precedingSpaces + formattedStr;
            }//End of for isfl

         //check line ctr then print
         if ( ! printHyphenStr.trim().equals(""))
            {
            if (lineCtrint >= linesPerPageint -1)
              {
              PrintMethod("" + ff);
              PrintHeader();
              }
            PrintMethod(printHyphenStr);
            PrintMethod(printStr);
            lineCtrint = lineCtrint + 2;
            }
         }
      catch(Exception e)
         {
         e.printStackTrace();
         }
      }

   public static void Quit()
      {
      try
         {
         c.close();
         }
      catch(Exception e)
         {
         System.out.println("\nError during close method");
         e.printStackTrace();
         }
      System.exit(0);
      }

   public void ReadPropertiesFile(String propertiesFileName)
      {
      String wholeStr = "";
      String itemNameStr = "";
      String itemDataStr = "";
      byte arrow = (byte) '>';
      try
         {
         BufferedReader in  =  new BufferedReader(new FileReader(propertiesFileName));
         while ((wholeStr = in.readLine()) != null)
            {
            byte[] ba = wholeStr.getBytes();
            for(int i=0; i < wholeStr.length(); )
               {
               while (ba[i] != arrow)
                  {
                  itemNameStr = itemNameStr + (char) ba[i];
                  i = i + 1;
                  }
               i = i + 1;  //To skip the > after name
               itemDataStr = wholeStr.substring(i,wholeStr.length());

               //Put data into variables
               if (itemNameStr.equals("comment"))
                  {
                  //Ignore comments
                  }
               else if (itemNameStr.equals("mode"))
                  {
                  propertiesFileMode = itemDataStr;
                  }
               else if (itemNameStr.equals("driverclass"))
                  {
                  connectionPanelDriverClassTxt.setText(itemDataStr);
                  }
               else if (itemNameStr.equals("url"))
                  {
                  connectionPanelURLTxt.setText(itemDataStr);
                  }
               else if (itemNameStr.equals("user"))
                  {
                  connectionPanelUserTxt.setText(itemDataStr);
                  }
               else if (itemNameStr.equals("password"))
                  {
                  connectionPanelPasswordTxt.setText(itemDataStr);
                  }
               else if (itemNameStr.equals("reportname"))
                  {
                  chosenReport = itemDataStr;
                  }
               else if (itemNameStr.equals("reportdestination"))
                  {
                  file = new File(itemDataStr);
                  }

               itemNameStr = "";
               i= wholeStr.length();
               }
            }
         in.close();
         }
      catch(Exception e)
         {
         e.printStackTrace();
         }
      }

   public void Retrieve()
      {
      errMsg = "am in Retrieve method";
      int sqlRet = 0;
      String wholeStr = "";
      String itemNameStr = "";
      String itemDataStr = "";
      byte arrow = (byte) '>';
      try
         {
         //Build sql statement
         rs = st.executeQuery("select * from GReports where GRepName = '"+chosenReport+"' ");
         while(rs.next())
            {
            wholeStr = rs.getString("GRepData");
            }
         byte[] ba = wholeStr.getBytes();
         for(int i=0; i < wholeStr.length(); )
            {
            while (ba[i] != arrow)
               {
               itemNameStr = itemNameStr + (char) ba[i];
               i = i + 1;
               }
            i = i + 1;  //To skip the > after name
            while (ba[i] != 10)
               {
               itemDataStr = itemDataStr + (char) ba[i];
               i = i + 1;
               }
        /*
            System.out.println("\nnameStr is");
            System.out.println(itemNameStr);
            System.out.println("dataStr is");
            System.out.println(itemDataStr);
        */

            //Put data back into lists or vectors
            if (itemNameStr.equals("fieldsPanelFieldsListModel"))
               {
               fieldsPanelFieldsListModel.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("fieldsPanelSelectedListModel"))
               {
               fieldsPanelSelectedListModel.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("sortbyPanelFieldsListModel"))
               {
               sortbyPanelFieldsListModel.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("sortbyPanelSortedListModel"))
               {
               sortbyPanelSortedListModel.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("groupbyPanelFieldsListModel"))
               {
               groupbyPanelFieldsListModel.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("groupbyPanelGroupsListModel"))
               {
               groupbyPanelGroupsListModel.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("totalsPanelGroupsListModel"))
               {
               totalsPanelGroupsListModel.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("totalsGrpVec"))
               {
               totalsGrpVec.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("totalsColToTotVec"))
               {
               totalsColToTotVec.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("colNamVec"))
               {
               colNamVec.addElement(itemDataStr);
               }
            else if (itemNameStr.equals("totWidthVec"))
               {
               totWidthVec.addElement(Integer.valueOf(itemDataStr));
               }
            else if (itemNameStr.equals("decVec"))
               {
               decVec.addElement(Integer.valueOf(itemDataStr));
               }
            else if (itemNameStr.equals("heading"))
               {
               headingsPanelTextArea.append(itemDataStr);
               headingsPanelTextArea.append("\n");
               }
            else if (itemNameStr.equals("chosenTable"))
               {
               chosenTable = itemDataStr;
               }
            else if (itemNameStr.equals("linesPerPage"))
               {
               linesPerPage.setText(itemDataStr);
               }

            itemNameStr = "";
            itemDataStr = "";
            i = i + 1;  //to get to beginning of next name
            }
         }
      catch(Exception e)
         {
         System.out.println("\nError during retrieve method");
         e.printStackTrace();
         }
      }

   public void RunAutomatically()
      {
      //We're running without an interactive user
      ConnectToDatabase();
      Retrieve();
      printMode = "file";
      try
         {
         out  =  new PrintWriter(new BufferedWriter(new FileWriter(file.toString())));
         }
      catch(Exception f)
         {
         f.printStackTrace();
         }
      WriteReport();
      out.close();
      Quit();
      }

   public void Save()
      {
      errMsg = "am in Save method";
      sqlRet = 0;
      String reportDataStr = "";
      reportDataStr = BuildDataString();
      try
         {
         //Execute statement
         //System.out.println("Before saving data reportDataStr is--many lines");
         //System.out.println(reportDataStr);
         sqlRet = st.executeUpdate("update GReports set GRepData = '"+reportDataStr+"' where GRepName = '"+chosenReport+"' ");
         //System.out.println("sqlRet is " + sqlRet);

         //Check it out
       /*  rs = st.executeQuery("select * from GReports where Name = 'first'");
         while(rs.next())
            {
            String parseStr = rs.getString("Data");
            System.out.println("parseStr is: ");
            System.out.println(parseStr);
            byte[] ba = parseStr.getBytes();
            for(int i=0; i < parseStr.length() ; i++)
               {
               System.out.println("i is: " + i);
               System.out.println("as a char ba[i] is: " + (char)ba[i]);
               System.out.println("as a byte ba[i] is: " + ba[i]);
               }
            }
         */
         }
      catch(Exception e)
         {
         System.out.println("\nError during save method");
         e.printStackTrace();
         }
      }

   public void SaveAs()
      {
      if (generatePanelSaveAsTextField.getText().trim().equals("")
         || generatePanelSaveAsTextField.getText().equals("Enter Report Name"))
         {
         generatePanelSaveAsTextField.setText("Enter Report Name");
         }
      else
         {
         errMsg = "am in SaveAs method";
         sqlRet = 0;
         String reportDataStr = "";
         reportDataStr = BuildDataString();

         try
            {
            //Execute statement
            //System.out.println("Before SaveAs data reportDataStr is--many lines");
            //System.out.println(reportDataStr);
            sqlRet = st.executeUpdate("insert into GReports values('"+generatePanelSaveAsTextField.getText()+"','"+reportDataStr+"')");
            //System.out.println("sqlRet is " + sqlRet);

            //Check it out
          /*  rs = st.executeQuery("select * from GReports where Name = 'first'");
            while(rs.next())
               {
               String parseStr = rs.getString("Data");
               System.out.println("parseStr is: ");
               System.out.println(parseStr);
               byte[] ba = parseStr.getBytes();
               for(int i=0; i < parseStr.length() ; i++)
                  {
                  System.out.println("i is: " + i);
                  System.out.println("as a char ba[i] is: " + (char)ba[i]);
                  System.out.println("as a byte ba[i] is: " + ba[i]);
                  }
               }
            */
            }
         catch(Exception e)
            {
            System.out.println("\nError during SaveAs method");
            e.printStackTrace();
            }

         generatePanelSaveBtn.setEnabled(true);
         chosenReport = generatePanelSaveAsTextField.getText();
         generatePanelSaveAsTextField.setText("");
         mode = "modify";
         }
      }

   public void SetUpPanels()
      {
      //I realize all the following scroll pane setups
      //should be moved to a method using parameters.

      //Put reports list into a scroll pane
      reportsPanelReportsScrollPane.getViewport().setView(reportsPanelReportsList);
      reportsPanelReportsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      reportsPanelReportsList.setSelectedIndex(0);
      reportsPanelReportsList.addListSelectionListener(this);
      //Set up double click for list
      reportsPanelReportsList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               reportsPanelRunBtn.doClick();
               }
            }
          });

      //Put tables list into a scroll pane
      tablesPanelTablesScrollPane.getViewport().setView(tablesPanelTablesList);
      tablesPanelTablesList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      tablesPanelTablesList.setSelectedIndex(0);
      tablesPanelTablesList.addListSelectionListener(this);
      //Set up double click for list
      tablesPanelTablesList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               tablesPanelSelectBtn.doClick();
               }
            }
          });

      //Put fields list into a scroll pane
      fieldsPanelFieldsScrollPane.getViewport().setView(fieldsPanelFieldsList);
      fieldsPanelFieldsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      fieldsPanelFieldsList.setSelectedIndex(0);
      fieldsPanelFieldsList.addListSelectionListener(this);
      //Set up double click for list
      fieldsPanelFieldsList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               fieldsPanelRightArrowBtn.doClick();
               }
            }
          });

      //Put selected fields list into a scroll pane
      fieldsPanelSelectedScrollPane.getViewport().setView(fieldsPanelSelectedList);
      fieldsPanelSelectedList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      fieldsPanelSelectedList.setSelectedIndex(0);
      fieldsPanelSelectedList.addListSelectionListener(this);
      fieldsPanelSelectedList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               fieldsPanelLeftArrowBtn.doClick();
               }
            }
          });

      //Put sortby fields list into a scroll pane
      sortbyPanelFieldsScrollPane.getViewport().setView(sortbyPanelFieldsList);
      sortbyPanelFieldsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      sortbyPanelFieldsList.setSelectedIndex(0);
      sortbyPanelFieldsList.addListSelectionListener(this);
      //Set up double click for list
      sortbyPanelFieldsList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               sortbyPanelRightArrowBtn.doClick();
               }
            }
          });

      //Put sortby sorted list into a scroll pane
      sortbyPanelSortedScrollPane.getViewport().setView(sortbyPanelSortedList);
      sortbyPanelSortedList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      sortbyPanelSortedList.setSelectedIndex(0);
      sortbyPanelSortedList.addListSelectionListener(this);
      //Set up double click for list
      sortbyPanelSortedList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               sortbyPanelLeftArrowBtn.doClick();
               }
            }
          });

      //Put groupby fields list into scroll pane
      groupbyPanelFieldsScrollPane.getViewport().setView(groupbyPanelFieldsList);
      groupbyPanelFieldsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      groupbyPanelFieldsList.setSelectedIndex(0);
      groupbyPanelFieldsList.addListSelectionListener(this);
      //Set up double click for list
      groupbyPanelFieldsList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               groupbyPanelRightArrowBtn.doClick();
               }
            }
          });  //End of addMouseListener(new MouseAdapter()

      //Put groupby groups list into scroll pane
      groupbyPanelGroupsScrollPane.getViewport().setView(groupbyPanelGroupsList);
      groupbyPanelGroupsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      groupbyPanelGroupsList.setSelectedIndex(0);
      groupbyPanelGroupsList.addListSelectionListener(this);
      //Set up double click for list
      groupbyPanelGroupsList.addMouseListener(new MouseAdapter()
         {
         public void mouseClicked(MouseEvent e)
            {
            if (e.getClickCount() == 2)
               {
               groupbyPanelLeftArrowBtn.doClick();
               }
            }
          });  //End of addMouseListener(new MouseAdapter()

      //Set up totals panel
      totalsPanelGroupsScrollPane.getViewport().setView(totalsPanelGroupsList);
      totalsPanelGroupsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      totalsPanelGroupsList.setSelectedIndex(0);
      totalsPanelGroupsList.addListSelectionListener(this);

      setUpIntEdit(totalsPanelTotalsTable);
      totalsPanelTotalsScrollPane.getViewport().setView(totalsPanelTotalsTable);

      //Set up format panel
      formatPanelFormatTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
      TableColumn colNameColumn = formatPanelFormatTable.getColumn("Column Name");
      colNameColumn.setPreferredWidth(200);

      TableColumn totWidthColumn = formatPanelFormatTable.getColumn("Total Width");
      totWidthColumn.setPreferredWidth(150);

      TableColumn decimalsColumn = formatPanelFormatTable.getColumn("Decimals");
      decimalsColumn.setPreferredWidth(150);

      setUpIntEdit(formatPanelFormatTable);
      formatPanelScrollPane.getViewport().setView(formatPanelFormatTable);

      //Put View text area into scroll pane
      viewPanelScrollPane.getViewport().setView(viewPanelTextArea);
      viewPanelTextArea.setFont(new Font("Monospaced", Font.PLAIN,13));

      //Now set up Headings text area
      headingsPanelScrollPane.getViewport().setView(headingsPanelTextArea);
      headingsPanelTextArea.setFont(new Font("Monospaced", Font.PLAIN,13));
      }

    private void setUpIntEdit(JTable table)
       {
       final IntegerNumField integerField = new IntegerNumField(0, 5);
       integerField.setHorizontalAlignment(IntegerNumField.RIGHT);
       DefaultCellEditor intEdit = new DefaultCellEditor(integerField)
          {
          public Object getCellEditorValue()
             {
             return new Integer(integerField.getValue());
             }
          };
        table.setDefaultEditor(Integer.class, intEdit);
        }

   public void StartOver()
      {
      EmptyAll();
      chosenReport = "";
      chosenTable = "";
      chosenField = "";
      linesPerPage.setText("60");

      tabbedPane.setEnabledAt(reports, true);
      tabbedPane.setEnabledAt(tables, false);
      tabbedPane.setEnabledAt(fields, false);
      tabbedPane.setEnabledAt(sortby, false);
      tabbedPane.setEnabledAt(groupby, false);
      tabbedPane.setEnabledAt(totals, false);
      tabbedPane.setEnabledAt(headings, false);
      tabbedPane.setEnabledAt(format, false);
      tabbedPane.setEnabledAt(generate, false);
      tabbedPane.setEnabledAt(view, false);

      tabbedPane.setSelectedIndex(reports);

      }


   public void stateChanged(ChangeEvent e)
      {
      //This method is executed when user changes to another tabbed pane
      JTabbedPane source = (JTabbedPane)e.getSource();
      //Next statement only prints "tabbedpane" over and over
      //Don't use it
      //System.out.println(source.getName());

      whereAm = source.getSelectedIndex();
      paneChain = paneChain + String.valueOf(whereAm);

      //Following if stm't is used to detect when user
      //exited certain panes
      if (wasInWhichPane == fields)
         {
         SynchAgainstSelectedFields();
         FillFormatPanelFormatTable();
         }
      else if (wasInWhichPane == groupby)
         {
         SynchAfterLeavingGroupby();
         }
      //Make the pane user is entering the new wasIn pane
      wasInWhichPane = whereAm;

      //Following if stm't handles when user enters a pane
      if (whereAm == connection)
         {

         }

      else if (whereAm == reports)
         {
         reportsPanelReportsListModel.removeAllElements();
         FillReportsList();
         //Set the buttons
         if (reportsPanelReportsListModel.getSize() == 0)
            {
            reportsPanelDeleteBtn.setEnabled(false);
            reportsPanelModifyBtn.setEnabled(false);
            reportsPanelRunBtn.setEnabled(false);
            }
         else
            {
            reportsPanelDeleteBtn.setEnabled(true);
            reportsPanelModifyBtn.setEnabled(true);
            reportsPanelRunBtn.setEnabled(true);
            }
         reportsPanelReportsList.setSelectedIndex(0);
         }

      else if (whereAm == tables)
         {
         tablesPanelTablesListModel.removeAllElements();
         FillTablesList();
         //Set the select button
         if (tablesPanelTablesListModel.getSize() == 0)
            {
            tablesPanelSelectBtn.setEnabled(false);
            }
         else
            {
            tablesPanelSelectBtn.setEnabled(true);
            }
         tablesPanelTablesList.setSelectedIndex(0);
         }

      else if (whereAm == fields)
         {
         if (fieldsPanelFieldsListModel.getSize() == 0)
            {
            fieldsPanelRightArrowBtn.setEnabled(false);
            }
         else
            {
            fieldsPanelRightArrowBtn.setEnabled(true);
            }
         if (fieldsPanelSelectedListModel.getSize() == 0)
            {
            fieldsPanelLeftArrowBtn.setEnabled(false);
            }
         else
            {
            fieldsPanelLeftArrowBtn.setEnabled(true);
            }
         fieldsPanelFieldsList.setSelectedIndex(0);
         fieldsPanelSelectedList.setSelectedIndex(0);
         }

      else if (whereAm == sortby)
         {
         //Load the selected fields list that's not already in the
         //left scroll pane or the right scroll pane
         //into the left scroll pane
         size = fieldsPanelSelectedListModel.getSize();
         if (size > 0)
            {
            for (int i = 0; i <= size -1; i++)
               {
               if (! sortbyPanelFieldsListModel.contains(fieldsPanelSelectedListModel.elementAt(i))
                  && ! sortbyPanelSortedListModel.contains(fieldsPanelSelectedListModel.elementAt(i)))
                  {
                  sortbyPanelFieldsListModel.addElement(fieldsPanelSelectedListModel.elementAt(i));
                  }
               }
            }
         if (sortbyPanelFieldsListModel.getSize() == 0)
            {
            sortbyPanelRightArrowBtn.setEnabled(false);
            }
         else
            {
            sortbyPanelRightArrowBtn.setEnabled(true);
            }
         if (sortbyPanelSortedListModel.getSize() == 0)
            {
            sortbyPanelLeftArrowBtn.setEnabled(false);
            }
         else
            {
            sortbyPanelLeftArrowBtn.setEnabled(true);
            }
         sortbyPanelFieldsList.setSelectedIndex(0);
         sortbyPanelSortedList.setSelectedIndex(0);
         }
      else if (whereAm == groupby)
         {
         //Load the fields list in the left scroll pane
         size = fieldsPanelSelectedListModel.getSize();
         if (size > 0)
            {
            for (int i = 0; i <= size -1; i++)
               {
               //Add to groupsfieldslistmodel (left side of screen)
               //elements from selectedfieldslist
               //not already in either side of screen
               if (! groupbyPanelFieldsListModel.contains(fieldsPanelSelectedListModel.elementAt(i))
                  && ! groupbyPanelGroupsListModel.contains(fieldsPanelSelectedListModel.elementAt(i)))
                  {
                  groupbyPanelFieldsListModel.addElement(fieldsPanelSelectedListModel.elementAt(i));
                  }
               }
            }
         if (groupbyPanelFieldsListModel.getSize() == 0)
            {
            groupbyPanelRightArrowBtn.setEnabled(false);
            }
         else
            {
            groupbyPanelRightArrowBtn.setEnabled(true);
            }
         if (groupbyPanelGroupsListModel.getSize() == 0)
            {
            groupbyPanelLeftArrowBtn.setEnabled(false);
            }
         else
            {
            groupbyPanelLeftArrowBtn.setEnabled(true);
            }
         groupbyPanelFieldsList.setSelectedIndex(0);
         groupbyPanelGroupsList.setSelectedIndex(0);
         }
      else if (whereAm == totals)
         {
         totalsPanelGroupsListModel.removeAllElements();
         //Data is coming from groupby pane into totals pane
         int sizegpglm = groupbyPanelGroupsListModel.getSize();
         if (sizegpglm > 0)
            {
            for (int i = 0; i <= sizegpglm -1; i++)
               {
               totalsPanelGroupsListModel.addElement(groupbyPanelGroupsListModel.elementAt(i));
               }
            }
         totalsPanelGroupsListModel.addElement("End Of Report");
         totalsPanelGroupsList.setSelectedIndex(0);
         //Put data into totals table
         FillTotalsPanelTotalsTable(totalsPanelGroupsList.getSelectedValue().toString());
         totalsPanelTotalsTable.setEditingRow(0);
         }
      else if (whereAm == format)
         {
         FillFormatPanelFormatTable();
         }

      else if (whereAm == headings)
         {
         try
            {
            int linBegOff = 0;
            int linEndOff = 0;
            int linCnt = headingsPanelTextArea.getLineCount();
            if (linCnt== 0)
               {
               headingsPanelTextArea.append("--------10--------20--------30--------40--------50--------60--------70--------80--------90-------100-------110-------120-------130-------140-------150-------160-------170-------180-------190-------200\n");
               headingsPanelTextArea.setCaretPosition(201);
               }
            else
               {
               headingsPanelTextArea.setCaretPosition(0);
               }
            }
         catch(Exception f)
            {
            f.printStackTrace();
            }
         headingsPanelTextArea.requestFocus();
         }
      else if (whereAm == generate)
         {
         if (mode.equals("new"))
            {
            generatePanelSaveBtn.setEnabled(false);
            }
         else if (mode.equals("modify"))
            {
            generatePanelSaveBtn.setEnabled(true);
            }
         }
      else if (whereAm == view)
         {

         }
      }

   public static String StringPadRight(String str, int wantLen)
      {
      int strLen = str.length();
      int addHowManyRight = wantLen - strLen;
      if (addHowManyRight > 0)  //pad on the right
         {
         for (int i = 1; i <= addHowManyRight; i++)
            {
            str = str + " ";
            }
         }
      else if (addHowManyRight < 0)  //str was too long to begin with
         {
         str = str.substring(0,wantLen);
         }
      return str;
      }

   public void SynchAfterLeavingGroupby()
      {
      for (int i = totalsGrpVec.size() -1; i >= 0 ; i--)
         {
         if ( ! groupbyPanelGroupsListModel.contains(totalsGrpVec.elementAt(i))
            && ! totalsGrpVec.elementAt(i).toString().equals("End Of Report"))
            {
            totalsGrpVec.removeElementAt(i);
            totalsColToTotVec.removeElementAt(i);
            }
         }
      }

      public void SynchAgainstSelectedFields()
         {
         //Doesn't really synch, just handles deletions from selected fields list
         SynchListModel(sortbyPanelFieldsListModel);
         SynchListModel(sortbyPanelSortedListModel);
         SynchListModel(groupbyPanelFieldsListModel);
         SynchListModel(groupbyPanelGroupsListModel);
         SynchListModel(totalsPanelGroupsListModel);

         for (int i = totalsGrpVec.size() -1; i >= 0 ; i--)
            {
            if ( ! fieldsPanelSelectedListModel.contains(totalsGrpVec.elementAt(i))
               && ! totalsGrpVec.elementAt(i).toString().equals("End Of Report"))
               {
               totalsGrpVec.removeElementAt(i);
               totalsColToTotVec.removeElementAt(i);
               }
            }

         for (int i = totalsColToTotVec.size() -1; i >= 0 ; i--)
            {
            if ( ! fieldsPanelSelectedListModel.contains(totalsColToTotVec.elementAt(i)))
               {
               totalsColToTotVec.removeElementAt(i);
               totalsGrpVec.removeElementAt(i);
               }
            }

         for (int i = colNamVec.size() -1; i >= 0 ; i = i - 2)
            {
            if ( ! fieldsPanelSelectedListModel.contains(colNamVec.elementAt(i)))
               {
               colNamVec.removeElementAt(i);
               totWidthVec.removeElementAt(i);
               decVec.removeElementAt(i);
               colNamVec.removeElementAt(i-1);  //get rid of matching "spaces before" row
               totWidthVec.removeElementAt(i-1);
               decVec.removeElementAt(i-1);
               }
            }
         }

      public void SynchListModel(DefaultListModel lm2)
         {
         //Doesn't really synch, just handles deletions from selected fields list
         for (int i = lm2.getSize() -1; i >= 0 ; i--)
            {
            if ( ! fieldsPanelSelectedListModel.contains(lm2.getElementAt(i)))
               {
               lm2.removeElementAt(i);
               }
            }
         }

   public void valueChanged(ListSelectionEvent e)
      {
      Object whichList = e.getSource();
      //Set switch to avoid registering same event twice
      if (tripsThruListEvent == false)
         {
         tripsThruListEvent = true;
         }
      else
         {
         tripsThruListEvent = false;
         }

      //Now deal with who changed
      if (tripsThruListEvent == true)
         {
         if (whichList == totalsPanelGroupsList)
            {
            FillTotalsPanelTotalsTable(totalsPanelGroupsList.getSelectedValue().toString());
            totalsPanelTotalsTable.repaint();
            }
         }
      }

   public void WriteReport()
      {
      int colTypNum = 0;
      String colTypName = "";
      String colTypName2 = "";
      String recStr = "";
      String printStr = "";
      int lineCtr = 0;
      int pageCtr = 0;
      boolean firstRec = true;
      Vector recVec = new Vector();
      int howManyGroups = groupbyPanelGroupsListModel.getSize();
      int sizeTotalsGrpVec = totalsGrpVec.size();
      String iFindCol4 = "";

      int elemNum = 0;
      int elemNum2 = 0;
      int elemNum3 = 0;
      size = fieldsPanelSelectedListModel.getSize();
      int sizeSort = sortbyPanelSortedListModel.getSize();
      String checkForNull = "";
      Double zeroD = new Double(0);
      BigDecimal zeroBD = new BigDecimal("0");
      String formattedStr = "";
      String colNameFor = "";
      int colNoFor = 0;
      int totWidFor = 0;
      int decWidFor = 0;
      String precedingSpaces = "";
      linesPerPageint = Integer.valueOf(linesPerPage.getText()).intValue();

      //Zero out totals vector
      for (int ittv = 0; ittv <= sizeTotalsGrpVec -1; ittv++)
         {
         totalsTotalsVec.addElement(String.valueOf(0));
         }

      //Get resultset and metadata
      if (size > 0)
         {
         try
            {
            String chosenFields = "";
            String sep = "";
            //To put commas between field names in sql statement
            for (int is = 0; is <= size -1; is++)
               {
               if (is > 0)
                  {
                  sep = ", ";
                  }
               chosenFields = chosenFields + sep + fieldsPanelSelectedListModel.getElementAt(is);
               }
            String sql = "select " + chosenFields + " from " + chosenTable ;

            //Now add the order by clause if necessary
            sep = "";
            String sortbyStr = "";
            if (sizeSort > 0)
               {
               for (int is = 0; is <= sizeSort -1; is++)
                  {
                  if (is > 0)
                     {
                     sep = ", ";
                     }
                  sortbyStr = sortbyStr + sep + sortbyPanelSortedListModel.getElementAt(is);
                  }
               sql = sql + " ORDER BY " + sortbyStr;
               }

            //System.out.println("SQL stm't is: " + sql);
            rs = st.executeQuery(sql);
            ResultSetMetaData md = rs.getMetaData();

            //Empty prevValueVec
            prevValueVec = new Vector();

            PrintHeader();

            //Start through the data
            while (rs.next())
               {
               errMsg = "just started while rs.next";
               //Store record to recVec
               recVec = new Vector();
               for (int iloadrv=1; iloadrv<= md.getColumnCount(); iloadrv++)
                  {
                  checkForNull = rs.getString(iloadrv);
                  if (checkForNull != null)
                     {
                     recVec.addElement(checkForNull);
                     }
                  else
                     {
                     recVec.addElement("");
                     }
                  }

               //Load values from first record into prev values vector
               if (firstRec)
                  {
                  for (int ipvv = 0; ipvv <= howManyGroups -1 ;ipvv++)
                     {
                     for (int ifc=1; ifc <=md.getColumnCount(); ifc++)
                        {
                        if (groupbyPanelGroupsListModel.elementAt(ipvv).toString().equals(md.getColumnName(ifc)))
                           {
                           //Am going to use -1 in next command
                           //because elements start at 0 and columns start at 1
                           //prevValueVec is coming from a vec but by a colcount no.
                           prevValueVec.addElement(recVec.elementAt(ifc -1));
                           firstRec = false;
                           break;
                           }
                        }
                     }
                  }

               //Check if group total printing is necessary
               elemNum = 999;
               //Go through groups list
               for (int ihmg = 0; ihmg <= howManyGroups - 1; ihmg++)
                  {
                  errMsg = "got into for loop for ihmg";
                  //Find which column of rs to compare to previous value
                  //This is a do-it-yourself version of rs.findColumn since
                  //I shouldn't access each rs row more than once.
                  // Not all drivers support that.
                  for (int ifindcol=1; ifindcol <=md.getColumnCount(); ifindcol++)
                     {
                     if (groupbyPanelGroupsListModel.elementAt(ihmg).toString().equals(md.getColumnName(ifindcol)))
                        {
                        elemNum = ifindcol -1 ; //-1 because elem's start at 0 and columns start at 1
                        break;
                        }
                     }

                  //Is this a group break?
                  if ( ! prevValueVec.elementAt(ihmg).equals(recVec.elementAt(elemNum)))
                     {
                     errMsg = "inside if prevValueVec != ...";

                     //Do totals for all groups below this one and this one
                     //Start at bottom of groups list and work up
                     for (int ihmg3 = howManyGroups - 1; ihmg3 >= ihmg; ihmg3--)
                        {
                        for (int ifindcol4=1; ifindcol4 <=md.getColumnCount(); ifindcol4++)
                           {
                           if (groupbyPanelGroupsListModel.elementAt(ihmg3).toString().equals(md.getColumnName(ifindcol4)))
                              {
                              elemNum3 = ifindcol4 -1 ; //-1 because elem's start at 0 and columns start at 1
                              break;
                              }
                           }
                        //Store new value into prev value vec
                        prevValueVec.setElementAt(recVec.elementAt(elemNum3).toString(),ihmg3);
                        //Print the total line for that group break
                        if (totalsGrpVec.size() > 0)
                          {
                          PrintTotals(md, groupbyPanelGroupsListModel.elementAt(ihmg3).toString());
                          }
                        }
                        if (lineCtrint >= linesPerPageint)
                           {
                           PrintMethod(""+ff);
                           PrintHeader();
                           }
                        //Add a blank line after totals for better appearance
                        PrintMethod("");
                        lineCtrint = lineCtrint + 1;

                     }  //End of prev value not equal current recVec value
                  }//End of for ihmg

                  //Print the records
                  errMsg = "Am inside print records";
                  printStr = "";
                  for(int icc=1; icc<= md.getColumnCount(); icc++)
                     {
                     formattedStr = "";
                     recStr = recVec.elementAt(icc -1).toString();
                     colTypName = convertColTypToName(md.getColumnType(icc));
                     colNameFor = md.getColumnName(icc);
                     colNoFor = colNamVec.indexOf(colNameFor);
                     totWidFor = Integer.valueOf(totWidthVec.elementAt(colNoFor).toString()).intValue();
                     if (colTypName.equals("String"))
                        {
                        formattedStr = StringPadRight(recStr,totWidFor);
                        }
                     else if (colTypName.equals("int")
                        || colTypName.equals("long")
                        || colTypName.equals("float")
                        || colTypName.equals("double")
                        || colTypName.equals("BigDecimal"))
                        {
                        decWidFor = Integer.valueOf(decVec.elementAt(colNoFor).toString()).intValue();
                        formattedStr = NumPad(recStr,totWidFor,decWidFor,colTypName);
                        }
                     else if (colTypName.equals("Date"))
                        {
                        formattedStr = StringPadRight(recStr,totWidFor);
                        }
                     else
                        {
                        formattedStr = StringPadRight(colTypName + " data",totWidFor);
                        }
                     colNoFor = colNamVec.indexOf("spaces before " + colNameFor);
                     totWidFor = Integer.valueOf(totWidthVec.elementAt(colNoFor).toString()).intValue();
                     precedingSpaces = "";
                     for (int iprS = 1;iprS <= totWidFor; iprS++)
                        {
                        precedingSpaces = precedingSpaces + " ";
                        }
                     printStr = printStr + precedingSpaces + formattedStr;
                     }

                 if (lineCtrint >= linesPerPageint)
                    {
                    PrintMethod(""+ff);
                    PrintHeader();
                    }
                 PrintMethod(printStr);
                 lineCtrint = lineCtrint + 1;

                 //Add to totals
                 for (int ihmc = 0; ihmc <= sizeTotalsGrpVec - 1; ihmc++)
                    {
                    errMsg = "am inside adding to totals";
                    //Find which column of rs to add to totalsTotalsVec
                    //This is another do-it-yourself version of rs.findColumn
                    //--see same note in previous section
                    for (int ifindcol2=1; ifindcol2 <=md.getColumnCount(); ifindcol2++)
                       {
                       if (totalsColToTotVec.elementAt(ihmc).toString().equals(md.getColumnName(ifindcol2)))
                          {
                          elemNum2 = ifindcol2 - 1 ; //-1 because elem's start at 0 and columns start at 1
                          //Do the add. This isn't pretty
                          colTypName2 = convertColTypToName(md.getColumnType(ifindcol2));
                          if (colTypName2.equals("float")
                             || colTypName2.equals("double"))
                             {
                             double toBeAdded = 0;
                             double oldValue = Double.valueOf(totalsTotalsVec.elementAt(ihmc).toString()).doubleValue();
                             checkForNull = recVec.elementAt(elemNum2).toString();
                             if (checkForNull.length() != 0)
                                {
                                toBeAdded = Double.valueOf(checkForNull).doubleValue();
                                }
                             else
                                {
                                toBeAdded = 0;
                                }
                             double newValue = oldValue + toBeAdded;
                             Double newValueD = new Double(newValue);
                             totalsTotalsVec.setElementAt(newValueD ,ihmc);
                             }
                          else if (colTypName2.equals("int")
                                || colTypName2.equals("long")
                                || colTypName2.equals("BigDecimal"))
                             {
                             BigDecimal toBeAdded = new BigDecimal(0);
                             BigDecimal oldValue = new BigDecimal(totalsTotalsVec.elementAt(ihmc).toString());
                             checkForNull = recVec.elementAt(elemNum2).toString();
                             if (checkForNull.length() != 0)
                                {
                                toBeAdded = new BigDecimal(checkForNull);
                                }
                             else
                                {
                                toBeAdded = new BigDecimal(0);
                                }
                             BigDecimal newValueBD = new BigDecimal(0);
                             newValueBD = newValueBD.add(oldValue);
                             newValueBD = newValueBD.add(toBeAdded);
                             totalsTotalsVec.setElementAt(newValueBD ,ihmc);
                             }
                          break;
                          }
                       }
                    }
                    //Check totals vec's by outputing it
                    //System.out.println("Totals vec's are : ");
                    //for (int ick = 0; ick <= sizeTotalsGrpVec -1; ick++)
                       //{
                       //System.out.print(totalsGrpVec.elementAt(ick) + "  ");
                       //System.out.print(totalsColToTotVec.elementAt(ick) + "  ");
                       //System.out.println(totalsTotalsVec.elementAt(ick));
                       //}
               }//End of while.next()

            //Print final group totals
            for (int ihmg2 = howManyGroups - 1; ihmg2 >= 0; ihmg2--)
               {
               if (totalsGrpVec.size() > 0)
                 {
                 PrintTotals(md, groupbyPanelGroupsListModel.elementAt(ihmg2).toString());
                 }
               }

            if (lineCtrint >= linesPerPageint)
               {
               PrintMethod(""+ff);
               PrintHeader();
               }
            PrintMethod("");
            lineCtrint = lineCtrint + 1;

            //Print grand totals
            if (totalsGrpVec.size() > 0)
               {
               PrintTotals(md, "End Of Report");
               }

            }//End of try
         catch(Exception e)
            {
            System.out.println("\n\nFrom error catch, errMsg is: " + errMsg);
            e.printStackTrace();
            }
         }//End of size > 0
      }

   class FormatTableModel extends AbstractTableModel {

      final String[] columnNames = {"Column Name",
                                    "Total Width",
                                    "Decimals"};

      public int getColumnCount()
         {
         return columnNames.length;
         }

      public int getRowCount()
         {
         return formatTableVec.size();
         }

      public String getColumnName(int col)
         {
         return columnNames[col];
         }

      public Object getValueAt(int aRow, int aColumn)
         {
         Vector row = (Vector)formatTableVec.elementAt(aRow);
         return row.elementAt(aColumn);
         }

      public Class getColumnClass(int c)
         {
         return getValueAt(0, c).getClass();
         }

      public boolean isCellEditable(int row, int col)
         {
         if (col == 0)
            {
            return false;
            }
         else
            {
            return true;
            }
         }

      public void setValueAt(Object value, int row, int column)
         {
         Vector dataRow = (Vector)formatTableVec.elementAt(row);
         dataRow.setElementAt(value, column);
         Object fieldToLookFor = dataRow.elementAt(0);
         int searchReturned = colNamVec.indexOf(fieldToLookFor);
         if (searchReturned >= 0)
            {
            //Change the appropriate totWidth or decimal vec's
            if (column == 1)
               {
               totWidthVec.setElementAt(value, searchReturned);
               }
            else if (column == 2)
               {
               decVec.setElementAt(value, searchReturned);
               }
            else
               {
               System.out.println("\n\nERROR--column changed is higher than 2 ");
               }
            }
         else
            {
            System.out.println("\n\nERROR--changed row not in colNamVec ");
            }

         fireTableCellUpdated(row, column);
         }
      }

   class TotalsTableModel extends AbstractTableModel {
      final String[] columnNames = {"Total Y/N",
                                    "Column Name"};

      public int getColumnCount() {
          return columnNames.length;
         }

      public int getRowCount() {
          return data.length;
         }

      public String getColumnName(int col) {
          return columnNames[col];
         }

      public Object getValueAt(int row, int col) {
          return data[row][col];
         }

      public Class getColumnClass(int c) {
          return getValueAt(0, c).getClass();
         }

      public boolean isCellEditable(int row, int col)
         {
         if (col == 1)
            {
            return false;
            }
         else
            {
            return true;
            }
         }

      public void setValueAt(Object value, int row, int col)
         {
         //Either add it to or remove it from totals vectors
         if (String.valueOf(value) == "true")
            {
            totalsGrpVec.addElement(totalsPanelGroupsList.getSelectedValue().toString());
            totalsColToTotVec.addElement(String.valueOf(data[row][1]));
            }
         else if (String.valueOf(value) == "false")
            {
            for (int i = 0; i < totalsGrpVec.size();i++)
               {
               if (totalsGrpVec.elementAt(i).equals(totalsPanelGroupsList.getSelectedValue().toString())
                  && totalsColToTotVec.elementAt(i).equals(String.valueOf(data[row][1])))
                  {
                  totalsGrpVec.removeElementAt(i);
                  totalsColToTotVec.removeElementAt(i);
                  }
               }
            }
         else {System.out.println("Error--the value must be true or false");}

         //Original code
         data[row][col] = value;
         fireTableCellUpdated(row, col);
         }
      }

   }  //End of program
